#ifndef PARSER_HPP
#define PARSER_HPP

#include <list>
#include "data.hpp"

#define YYSTYPE void*

namespace parser {

    // Parameter to the parser.
    // users of this module must assign their own their own
    // input function to get_char()
    // Instead of returing the next character this may return 256, and
    // assign a number to *p (thus the return value is infact inside p)
	extern int (*get_char)(int* p);

	extern std::list<function>* program;
	extern bool yyparse(std::list<function>* pgm);
}

#endif
